routes/web.php
<?php

use App\Http\Controllers\CorrespondenciaController;
use App\Http\Controllers\DestinatarioController;

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('destinatarios', DestinatarioController::class);

Route::resource('correspondencias', CorrespondenciaController::class);

app/Models/Correspondencia.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Correspondencia extends Model
{
    use HasFactory;
    protected $fillable = [
        'fecha',
        'remitente',
        'asunto',
        'cite',
        'destinatario_id',
    ];

    public function destinatario()
    {
        return $this->belongsTo(Destinatario::class);
    }

}

app/Models/Destinatario.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Destinatario extends Model
{
    use HasFactory;
    protected $fillable = [
        'nombre',
        'cargo',
    ];

    public function correspondencias()
    {
        return $this->hasMany(Correspondencia::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/CorrespondenciaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Correspondencia;
use App\Models\Destinatario;
use Illuminate\Http\Request;

class CorrespondenciaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $correspondencias = Correspondencia::all();
        return view('correspondencias.index', [
            'correspondencias' => $correspondencias
        ]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $destinatarios = Destinatario::all();
        return view('correspondencias.create', [
            'destinatarios' => $destinatarios
        ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        Correspondencia::create($request->all());
        return redirect()->route('correspondencias.index');
    }

    /**
     * Display the specified resource.
     */
    public function show(Correspondencia $correspondencia)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Correspondencia $correspondencia)
    {
        $destinatarios = Destinatario::all();
        return view('correspondencias.edit', [
            'correspondencia' => $correspondencia,
            'destinatarios' => $destinatarios
        ]);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Correspondencia $correspondencia)
    {
        $correspondencia->update($request->all());
        return redirect()->route('correspondencias.index');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Correspondencia $correspondencia)
    {
        $correspondencia->delete();
        return redirect()->route('correspondencias.index');
    }
}

app/Http/Controllers/DestinatarioController.php
<?php

namespace App\Http\Controllers;

use App\Models\Destinatario;
use Illuminate\Http\Request;

class DestinatarioController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $destinatarios = Destinatario::all();
        return view('destinatarios.index', [
            'destinatarios' => $destinatarios
        ]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(Destinatario $destinatario)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Destinatario $destinatario)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Destinatario $destinatario)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Destinatario $destinatario)
    {
        //
    }
}

resources/views/correspondencias/create.blade.php
@extends('layouts.app')

@section('content')
<div class="flex justify-center items-center flex-col w-full h-auto rounded-lg">
    <div class="w-1/2 flex justify-center items-center flex-col rounded-lg border border-blue-500">
        <div class="w-1/2">
            <form action="{{ route('correspondencias.store') }}" method="post">
                @csrf

                <br>





                <label for="fecha" class="block text-sm font-medium leading-6 text-gray-900">Fecha</label>
                <div class="mt-2">
                    <input id="fecha" name="fecha" type="date" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                </div>

                <div>
                    <label for="remitente" class="block text-sm font-medium leading-6 text-gray-900">remitente</label>
                    <div class="mt-2">
                        <input id="remitente" name="remitente" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                    </div>
                </div>

                <div>
                    <label for="asunto" class="block text-sm font-medium leading-6 text-gray-900">asunto</label>
                    <div class="mt-2">
                        <input id="asunto" name="asunto" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                    </div>
                </div>


                <div>
                    <label for="cite" class="block text-sm font-medium leading-6 text-gray-900">cite</label>
                    <div class="mt-2">
                        <input id="cite" name="cite" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                    </div>
                </div>

                <div>
                    <label for="destinatario_id" class="block text-sm font-medium leading-6 text-gray-900">Editorial</label>
                    <div class="mt-2">
                        <select id="destinatario_id" name="destinatario_id" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                            @foreach ($destinatarios as $destinatario)
                                <option value="{{ $destinatario->id }}">{{ $destinatario->nombre }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>


                <div class="mt-4">
                    <button type="submit" class="flex w-full justify-center rounded-md bg-indigo-600 px-3 py-1.5 text-sm font-semibold leading-6 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">Registrar Correspondencia</button>
                </div>
            </form>
            <br>
        </div>
    </div>
</div>
@endsection

resources/views/correspondencias/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="flex justify-center items-center flex-col w-full h-auto rounded-lg">
    <div class="w-1/2 flex justify-center items-center flex-col rounded-lg border border-blue-500">
        <div class="w-1/2">
            <form action="{{ route('correspondencias.update', $correspondencia->id) }}" method="post">
                @csrf
                @method('PUT')

                <br>



                <div>
                    <label for="fecha" class="block text-sm font-medium leading-6 text-gray-900">Fecha de Vencimiento</label>
                    <div class="mt-2">
                        <input id="fecha" name="fecha" type="date" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" value="{{$correspondencia->fecha}}">
                    </div>
                </div>

                <div>
                    <label for="remitente" class="block text-sm font-medium leading-6 text-gray-900">Código Producto</label>
                    <div class="mt-2">
                        <input id="remitente" name="remitente" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" value="{{$correspondencia->remitente}}">
                    </div>
                </div>

                <div>
                    <label for="asunto" class="block text-sm font-medium leading-6 text-gray-900">Código Producto</label>
                    <div class="mt-2">
                        <input id="asunto" name="asunto" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" value="{{$correspondencia->remitente}}">
                    </div>
                </div>

                <div>
                    <label for="cite" class="block text-sm font-medium leading-6 text-gray-900">Código Producto</label>
                    <div class="mt-2">
                        <input id="cite" name="cite" type="text" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" value="{{$correspondencia->remitente}}">
                    </div>
                </div>


                <div>
                    <label for="destinatario_id" class="block text-sm font-medium leading-6 text-gray-900">Proveedor</label>
                    <div class="mt-2">
                        <select id="destinatario_id" name="destinatario_id" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
                            @foreach ($destinatarios as $destinatario)
                                <option value="{{ $destinatario->id }}" {{ $destinatario->id == $destinatario->destinatario_id ? 'selected' : '' }}>{{ $destinatario->nombre }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>





                <div class="mt-4">
                    <button type="submit" class="flex w-full justify-center rounded-md bg-indigo-600 px-3 py-1.5 text-sm font-semibold leading-6 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">Actualizar</button>
                </div>
            </form>
            <br>
        </div>
    </div>
</div>
@endsection

resources/views/correspondencias/index.blade.php
@extends('layouts.app')

@section('content')

    <table class="min-w-full divide-y divide-gray-200 dark:divide-gray-700">
        <thead>
            <tr>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">ID</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Fecha</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Remitente</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Asunto</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Cite</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Destinatario</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">Acciones</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($correspondencias as $correspondencia)
            <tr>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->id }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->fecha }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->remitente }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->asunto }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->cite }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $correspondencia->destinatario->nombre }}</td>

                <td class="px-6 py-4 whitespace-nowrap">
                    <a class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded" href="{{ route('correspondencias.edit', $correspondencia->id) }}">Editar</a>
                    <form action="{{ route('correspondencias.destroy', $correspondencia->id) }}" method="POST" style="display:inline-block;">
                        @csrf
                        @method('DELETE')
                        <input class="bg-red-500 hover:bg-red-700 text-white font-bold py-2 px-4 rounded" type="submit" value="Eliminar">
                    </form>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>

    <a href="{{ route('correspondencias.create') }}" class="mt-4 bg-green-500 hover:bg-green-700 text-white font-bold py-2 px-4 rounded">.............Insertar........ </a>

@endsection

resources/views/destinatarios/index.blade.php
@extends('layouts.app')

@section('content')

    <table class="min-w-full divide-y divide-gray-200 dark:divide-gray-700">
        <thead>
            <tr>

                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">ID</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">nombre</th>
                <th class="px-6 py-3 bg-gray-50 dark:bg-gray-800">cargo</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($destinatarios as $destinatario)
            <tr>
                <td class="px-6 py-4 whitespace-nowrap">{{ $destinatario->id }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $destinatario->nombre }}</td>
                <td class="px-6 py-4 whitespace-nowrap">{{ $destinatario->cargo }}</td>

                <td class="px-6 py-4 whitespace-nowrap">
                    <a class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded" href="{{ route('destinatarios.edit', $destinatario->id) }}">Editar</a>
                    <form action="{{ route('destinatarios.destroy', $destinatario->id) }}" method="POST" style="display:inline-block;">
                        @csrf
                        @method('DELETE')
                        <input class="bg-red-500 hover:bg-red-700 text-white font-bold py-2 px-4 rounded" type="submit" value="Eliminar">
                    </form>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>

    <a href="{{ route('correspondencias.create') }}" class="mt-4 bg-green-500 hover:bg-green-700 text-white font-bold py-2 px-4 rounded">Insertar Libro</a>

@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>My Laravel App</title>
    <link href="https://cdn.jsdelivr.net/npm/tailwindcss@2.2.19/dist/tailwind.min.css" rel="stylesheet">


    <link rel="stylesheet" href="{{ asset('stilos/styles.css') }}">

    <style>

    </style>
    <script defer>
        function toggleMenu() {
            const menu = document.getElementById('mobile-menu');
            menu.classList.toggle('hidden');
        }
    </script>
</head>
<body >

    <!-- Header -->
    <header class="bg-blue-400 shadow-md p-4 mb-4 flex justify-between items-center">
        <div class="relative">
            <!-- Hamburger Menu Button -->
            <button onclick="toggleMenu()" class="text-gray-800 focus:outline-none lg:hidden">
                <svg class="w-6 h-6" fill="none" stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h16M4 18h16"></path>
                </svg>
            </button>

            <!-- Mobile Menu -->
            <div id="mobile-menu" class="hidden absolute bg-white shadow-lg rounded-lg mt-2 w-48 lg:block lg:relative lg:mt-0 lg:bg-transparent lg:shadow-none lg:rounded-none lg:flex lg:items-center">
                <ul class="flex flex-col lg:flex-row lg:space-x-4">
                    <li><a href="/" class="block py-2 px-4 text-gray-800 hover:bg-gray-200">Home</a></li>
                    <li><a href="{{ route('correspondencias.index') }}" class="block py-2 px-4 text-gray-800 hover:bg-gray-200">Correspondencia</a></li>
                    <li><a href="{{ route('destinatarios.index') }}" class="block py-2 px-4 text-gray-800 hover:bg-gray-200">Destinatarios</a></li>

                </ul>
            </div>
        </div>
        <h1 class="text-4xl font-bold text-white text-shadow">EXAMEN SEGUNDO PARCIAL </h1>
        <div>
            <h2 class="text-lg font-semibold">Bienvenido</h2>
        </div>
    </header>

    <!-- Main Content Area -->
    <div class="bg-white p-6 shadow-md flex-grow overflow-auto">
        @yield('content')
    </div>


</body>
</html>